#include <cmath>
#include <functional>
#include <fstream>
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <list>
#include <time.h>
#include <math.h>
#include <random>
#include <deque>
#include <queue>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <bitset>
#include <sstream>
#include <chrono>
#include <cstring>

using namespace std;

typedef long long ll;

mt19937 rnd(228);

const ll inf = (ll) (1e18) + 7;

const int N = 3e5;

ll dp[N];
int p[N];
int fenw[N];

int l_cost(int l) {
  int sum = 0;
  for (int x = p[l] - 1; x >= 0; x = (x & (x + 1)) - 1) {
    sum += fenw[x];
  }
  return sum;
}

int n, al, ar, len, x;
ll sum;

int r_cost(int r) {
  return len - l_cost(r) - 1;
}

void upd(int x, int type) {
  for (int t = p[x]; t < n; t = (t | (t + 1))) {
    fenw[t] += type;
  }
}

ll get_score(int l, int r) {
  while (ar < r) {
    upd(ar, 1);
    len++;
    sum += r_cost(ar);
    ar++;
  }
  while (al > l) {
    upd(al - 1, 1);
    len++;
    sum += l_cost(al - 1);
    al--;
  }
  while (ar > r) {
    sum -= r_cost(ar - 1);
    upd(ar - 1, -1);
    len--;
    ar--;
  }
  while (al < l) {
    sum -= l_cost(al);
    upd(al, -1);
    len--;
    al++;
  }
  return sum;
}

void move(int l, int r, int al, int ar) {
  if (l >= r) {
    return;
  }
  int m = (l + r) / 2;
  int opt = -1;
  ll best = inf;
  for (int i = al; i < ar; i++) {
    ll cur_score = dp[i] + get_score(i, m) + x;
    if (cur_score < best) {
      best = cur_score;
      opt = i;
    }
  }
  dp[m] = min(dp[m], best);
  move(l, m, al, opt + 1);
  move(m + 1, r, opt, ar);
}

void solve(int l, int r) {
  if (r - l > 1) {
    int m = (l + r) / 2;
    solve(l, m);
    for (int i = al; i < ar; i++) {
      upd(i, -1);
    }
    sum = len = 0;
    al = l, ar = l;
    move(m, r, l, m);
    solve(m, r);
  }
}

ll solve() {
  for (int i = 0; i <= n; i++) {
    dp[i] = inf;
  }
  dp[0] = 0;
  al = 0, ar = 0;
  len = 0;
  sum = 0;
  solve(0, n + 1);
  return dp[n];
}

int main() {
#ifdef iq
  freopen("a.in", "r", stdin);
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);
  cin >> n >> x;
  for (int i =0 ; i < n; i++) {
    cin >> p[i];
    p[i]--;
  }
  cout << solve() << '\n';
}
