// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

const int MAXN = 100007;

void solve() {
	int n, m;
	cin >> n >> m;
	vector<int> digits;
	for (int i = 0; i < m; ++i) {
		int d;
		cin >> d;
		digits.push_back(d);
	}

	vector<int> segs_in_dig = {6, 2, 5, 5, 4, 5, 6, 3, 7, 6};
	int first_dig = INF;
	int other_digs = INF;
	for (int d : digits) {
		if (d) {
			first_dig = min(first_dig, segs_in_dig[d]);
		}
		other_digs = min(other_digs, segs_in_dig[d]);
	}

	int len = 1 + max(0, n - first_dig) / other_digs;
	vector<bitset<MAXN>> dp(len);
	dp[0][0] = 1;
	vector<int> szs;
	for (int d : digits) {
		szs.push_back(segs_in_dig[d]);
	}
	szs.erase(unique(szs.begin(), szs.end()), szs.end());
	for (int i = 0; i < len - 1; ++i) {
		for (int sz : szs) {
			dp[i + 1] |= dp[i] << sz;
		}
	}
	reverse(digits.begin(), digits.end());
	int left = n;
	vector<int> ans;
	for (int i = 0; i < len; ++i) {
		for (int d : digits) {
			if (left - segs_in_dig[d] >= 0 && dp[len - i - 1][left - segs_in_dig[d]]) {
				ans.push_back(d);
				left -= segs_in_dig[d];
				break;
			}
		}
	}

	for (int d : ans) {
		cout << d;
	}
	cout << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}