#include <cmath>
#include <functional>
#include <fstream>
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <list>
#include <time.h>
#include <math.h>
#include <random>
#include <deque>
#include <queue>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <bitset>
#include <sstream>
#include <chrono>
#include <cstring>

using namespace std;

typedef long long ll;

#ifdef iq
  mt19937 rnd(228);
#else
  mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif

const int M = 998244353;

void add(int &a, int b) {
  a += b;
  if (a < 0) a += M;
  if (a >= M) a -= M;
}

int mul(int a, int b) {
  return (a * (ll) b) % M;
}

int pw(int a, int n) {
  int res = 1;
  while (n) {
    if (n % 2 == 0) {
      a = mul(a, a);
      n /= 2;
    } else {
      res = mul(res, a);
      n--;
    }
  }
  return res;
}

int inv(int x) {
  return pw(x, M - 2);
}

int main() {
#ifdef iq
  freopen("a.in", "r", stdin);
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);
  int n;
  cin >> n;
  n++;
  vector <int> fact(n + 1), rfact(n + 1);
  fact[0] = 1;
  for (int i = 1; i <= n; i++) {
    fact[i] = mul(fact[i - 1], i);
  }
  rfact[n] = inv(fact[n]);
  for (int i = n - 1; i >= 0; i--) {
    rfact[i] = mul(rfact[i + 1], i + 1);
  }
  vector <int> a(n - 1);
  for (int i = 0; i < n - 1; i++) {
    cin >> a[i];
  }
  sort(a.rbegin(), a.rend());
  auto comb = [&] (int n, int k) {
    if (n < k) return 0;
    return mul(fact[n], mul(rfact[k], rfact[n - k]));
  };
  int sum = 0;
  for (int i = 0; i < n - 1; i++) {
    int cost = mul(fact[n / 2], fact[n / 2]);
    cost = mul(cost, comb(n - i - 2, n / 2 - 1));
    add(sum, mul(cost, a[i]));
  }
  cout << sum << endl;
}

