#include <cmath>
#include <functional>
#include <fstream>
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <list>
#include <time.h>
#include <math.h>
#include <random>
#include <deque>
#include <queue>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <bitset>
#include <sstream>
#include <chrono>
#include <cstring>

using namespace std;

typedef long long ll;

#ifdef iq
  mt19937 rnd(228);
#else
  mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif

const int N = 101;
const int M = 998244353;

void add(int &a, int b) {
  a += b;
  if (a < 0) a += M;
  if (a >= M) a -= M;
}

int mul(int a, int b) {
  return (a * (ll) b) % M;
}

int dp[N][N][N];
int ways[N][N];
int comb[N][N];
int fact[N];
int pw[N];

int solve(vector <int> p, int k) {
  if (p.empty()) return 0;
  int x = max_element(p.begin(), p.end()) - p.begin();
  int l = x + 1;
  int r = (int) p.size() - x;
  int ot = min(k, min(l, r));
  int ans = mul(p[x], ot);
  l -= ot, r -= ot;
  k -= ot;
  if (l && k) {
    vector <int> mda;
    for (int t = 0; t < x; t++) {
      mda.push_back(p[t]);
    }
    add(ans, solve(mda, k));
  }
  if (r && k) {
    vector <int> mda;
    for (int t = x + 1; t < (int) p.size(); t++) {
      mda.push_back(p[t]);
    }
    add(ans, solve(mda, k));
  }
  return ans;
}

int stupid(int n) {
  vector <int> p(n);
  for (int i = 0; i < n; i++) p[i] = i + 1;
  int ans = 0;
  do {
    add(ans, solve(p, n / 2 + 1));
  } while (next_permutation(p.begin(), p.end()));
  return ans;
};

int main() {
#ifdef iq
  freopen("a.in", "r", stdin);
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);
  int n;
  cin >> n;
  n++;
  comb[0][0] = 1;
  fact[0] = 1;
  pw[0] = 1;
  for (int i = 1; i <= n; i++) {
    fact[i] = mul(fact[i - 1], i);
    pw[i] = mul(pw[i - 1], 2);
  }
  for (int i = 0; i <= n; i++) {
    for (int j = 0; j <= n; j++) {
      if (i)
        add(comb[i][j], comb[i - 1][j]);
      if (i && j)
        add(comb[i][j], comb[i - 1][j - 1]);
    }
  }
  auto divide = [&] (int a, int b, int i, int j) {
    int na = a - (i + 1);
    int nb = b - (j - i);
    return mul(comb[j][i], comb[na + nb][na]);
  };
  for (int i = 1; i <= n; i++) {
    if (i == 1) {
      ways[i][0] = 1;
    } else {
      for (int k = 0; k <= i / 2; k++) {
        for (int l = 1; l < i; l++) {
          int r = i - l;
          int a = min(l, r);
          int new_k = max(0, k - a);
          int grab = min(k, a);
          int b = max(l, r);
          int go = mul(comb[i - 2][l - 1], fact[a - 1]);
          add(dp[i][k][0], mul(grab, mul(ways[b][new_k], go)));
          add(ways[i][k], mul(ways[b][new_k], go));
          for (int j = 0; j < b - 1; j++) {
            int his_coef = dp[b][new_k][j];
            for (int id = j; id < (l - 1) + (r - 1); id++) {
              int coef = divide(b - 1, a - 1, j, id);
              add(dp[i][k][1 + id], mul(his_coef, mul(coef, fact[a - 1])));
            }
          }
        }
      }
    }
  }
  vector <int> a(n - 1);
  for (int i = 0; i < n - 1; i++) {
    cin >> a[i];
  }
  sort(a.rbegin(), a.rend());
  int sum = 0;
  for (int x = 0; x < n - 1; x++) {
    add(sum, mul(dp[n][n / 2][x], a[x]));
  }
  cout << sum << endl;
}
