#include "testlib.h"
#include <vector>

using namespace std;

constexpr int N = 100'000;
constexpr int M = 200'000;

void dfs(const vector<vector<int>>& gr, vector<bool>& used, int u) {
    used[u] = true;
    for (int v : gr[u]) {
        if (!used[v]) {
            dfs(gr, used, v);
        }
    }
}

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);

    int n = inf.readInt(2, N, "n");
    inf.readSpace();
    int m = inf.readInt(1, M, "m");
    inf.readEoln();

    vector<vector<int>> gr(n);

    for (int i = 0; i < m; ++i) {
        int a = inf.readInt(1, n, format("a[%d]", i + 1));
        inf.readSpace();
        int b = inf.readInt(1, n, format("b[%d]", i + 1));
        inf.readEoln();

        ensuref(a != b, "%d-th edge has equal endpoints", i + 1);
        gr[a - 1].push_back(b - 1);
        gr[b - 1].push_back(a - 1);
    }

    vector<bool> used(n);
    dfs(gr, used, 0);
    for (int i = 0; i < n; ++i) {
        ensuref(used[i], "vertex %d is not reachable from 1", i + 1);
    }

    inf.readEof();

    return 0;
}
