#include <iostream>
#include <vector>

using namespace std;

vector<vector<pair<int, int>>> gr;
vector<bool> used;
vector<int> enter, up;
vector<bool> bridge;
int t = 0;

void dfs1(int u, int p) {
    used[u] = true;
    enter[u] = t++;
    up[u] = enter[u];
    for (auto e : gr[u]) {
        if (e.second == p) {
            continue;
        }
        int v = e.first;
        if (used[v]) {
            up[u] = min(up[u], enter[v]);
        } else {
            dfs1(v, e.second);
            up[u] = min(up[u], up[v]);
        }
    }

    if (p != -1 && up[u] == enter[u]) {
        bridge[p] = true;
    }
}

vector<int> comp;

void dfs2(int u, int cc) {
    comp[u] = cc;
    for (auto e : gr[u]) {
        if (comp[e.first] == -1 && !bridge[e.second]) {
            dfs2(e.first, cc);
        }
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    gr.resize(n);
    used.resize(n);
    enter.resize(n);
    up.resize(n);
    bridge.resize(m);
    vector<int> u(m), v(m);
    for (int i = 0; i < m; ++i) {
        cin >> u[i] >> v[i];
        --u[i];
        --v[i];
        gr[u[i]].emplace_back(v[i], i);
        gr[v[i]].emplace_back(u[i], i);
    }

    dfs1(0, -1);

    comp.assign(n, -1);
    int cc = 0;
    for (int i = 0; i < n; ++i) {
        if (comp[i] == -1) {
            dfs2(i, cc++);
        }
    }

    vector<int> cnt(cc);
    for (int i = 0; i < m; ++i) {
        if (bridge[i]) {
            ++cnt[comp[u[i]]];
            ++cnt[comp[v[i]]];
        }
    }

    if (cc == 1) {
        cout << 0 << endl;
        return 0;
    }

    int res = 0;
    for (int i = 0; i < cc; ++i) {
        if (cnt[i] == 0) {
            return 1;
        }
        if (cnt[i] == 1) {
            ++res;
        }
    }

    cout << (res + 1) / 2 << endl;

    return 0;
}