// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<pii>> graph(n);
	vector<pii> edges;
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		--a; --b;
		graph[a].push_back({b, i});
		graph[b].push_back({a, i});
		edges.push_back({a, b});
	}

	vector<bool> used(n);
	vector<int> depth(n), up(n);
	vector<bool> bad_edge(m);
	function<void(int, int, int)> dfs = [&](int v, int e, int d) {
		used[v] = true;
		depth[v] = d;
		up[v] = d;
		for (auto to : graph[v]) {
			if (!used[to.ff]) {
				dfs(to.ff, to.ss, d + 1);
				up[v] = min(up[v], up[to.ff]);
				if (up[to.ff] == depth[to.ff]) {
					bad_edge[to.ss] = true;
				}
			} else if (to.ss != e) {
				up[v] = min(up[v], depth[to.ff]);
			}
		}
	};

	dfs(0, -1, 0);
	vector<int> comp(n);
	fill(used.begin(), used.end(), 0);
	int cnt = 0;
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			queue<int> qu;
			qu.push(i);
			used[i] = true;
			while (szof(qu)) {
				int v = qu.front();
				qu.pop();
				comp[v] = cnt;
				for (auto to : graph[v]) {
					if (!bad_edge[to.ss] && !used[to.ff]) {
						qu.push(to.ff);
						used[to.ff] = true;
					}
				}
			}
			++cnt;
		}
	}

	if (cnt == 1) {
		cout << "0\n";
		return;
	}

	vector<int> deg(cnt);
	for (int i = 0; i < m; ++i) {
		if (bad_edge[i]) {
			deg[comp[edges[i].ff]]++;
			deg[comp[edges[i].ss]]++;
		}
	}

	int q = 0;
	for (int i = 0; i < cnt; ++i) {
		q += deg[i] == 1;
	}

	cout << (q + 1) / 2 << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}