// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

void add(int& a, int b, int m) {
	a += b;
	if (a >= m) {
		a -= m;
	}
}

int mult(int a, int b, int m) {
	return (ll) a * b % m;
}

int mpow(int a, int b, int m) {
	int ret = 1;
	while (b) {
		if (b & 1) {
			ret = mult(ret, a, m);
		}
		a = mult(a, a, m);
		b /= 2;
	}
	return ret;
}

void solve() {
	int k, n, m;
	cin >> k >> n;
	m = 1000000007;

	vector<int> primes;
	int phi = 1;
	{
		int tmp = m;
		for (int i = 2; i * i <= tmp; ++i) {
			if (tmp % i == 0) {
				primes.push_back(i);
				int cp = 1;
				while (tmp % i == 0) {
					tmp /= i;
					cp *= i;
				}
				phi *= cp / i * (i - 1);
			}
		}
		if (tmp > 1) {
			primes.push_back(tmp);
			phi *= tmp - 1;
		}
	}

	vector<pair<int, vector<int>>> factorial;
	factorial.push_back({1, vector<int>(szof(primes))});
	for (int i = 1; i <= k; ++i) {
		factorial.push_back(factorial.back());
		int tmp = i;
		for (int j = 0; j < szof(primes); ++j) {
			while (tmp % primes[j] == 0) {
				tmp /= primes[j];
				factorial.back().ss[j]++;
			}
		}
		factorial.back().ff = mult(factorial.back().ff, tmp, m);
	}

	auto cnk = [&](int n, int k) {
		int ret = mult(factorial[n].ff, mpow(mult(factorial[k].ff, factorial[n - k].ff, m), phi - 1, m), m);
		for (int j = 0; j < szof(primes); ++j) {
			int cp = factorial[n].ss[j] - factorial[k].ss[j] - factorial[n - k].ss[j];
			ret = mult(ret, mpow(primes[j], cp, m), m);
		}
		return ret;
	};

	int ans = 0;

	for (int i = 0; i <= k; ++i) {
		if (i * 2 <= n && i + n - i * 2 <= k) {
			add(ans, mult(cnk(k, i), cnk(k - i, n - i * 2), m), m);
		}
	}

	cout << ans << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}