// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<int>> graph((n + 1) * 5);
	for (int i = 0; i <= n; ++i) {
		int center = i * 5;
		for (int j = 1; j <= 4; ++j) {
			graph[center].push_back(center + j);
			graph[center + j].push_back(center);
		}
		if (i < n) {
			graph[center].push_back(center + 5);
			graph[center + 5].push_back(center);
		}
	}

	m -= n;
	for (int j = 1; j <= 4; ++j) {
		int val = min(n, m);
		m -= val;
		for (int k = 0; k < val; ++k) {
			int center = k * 5;
			graph[center + j].push_back(center + 5 + j);
			graph[center + 5 + j].push_back(center + j);
		}
	}

	ll ans = 0;
	for (int i = 0; i < szof(graph); ++i) {
		vector<int> dist(szof(graph), INF);
		dist[i] = 0;
		queue<int> qu;
		qu.push(i);
		while (szof(qu)) {
			int v = qu.front();
			qu.pop();
			for (int to : graph[v]) {
				if (dist[to] > dist[v] + 1) {
					dist[to] = dist[v] + 1;
					qu.push(to);
				}
			}
		}
		ans += accumulate(dist.begin(), dist.end(), 0ll);
	}

	cout << ans / 2 << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}